@ECHO off
REM
REM THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
REM
REM  5724-I63, 5724-H88, 5655-N02, 5733-W70 (C) COPYRIGHT International Business Machines Corp. 2005, 2011
REM
REM  The source code for this program is not published or otherwise divested
REM  of its trade secrets, irrespective of what has been deposited with the
REM  U.S. Copyright Office.
REM
REM ----------------------------------------------------------------------------

SETLOCAL

SET TOOL_DIR=%~dp0

SET PARAMETER=
SET FILENAME=

IF [%1]==[] GOTO PRINT_USAGE

:PARAM_LOOP
IF [%1]==[] GOTO VERIFY_REQUIRED_INPUTS

IF [%1]==[-help] GOTO PRINT_USAGE
IF [%1]==[-?] GOTO PRINT_USAGE

IF [%1]==[-branch] SET PARAMETER=%PARAMETER% %1 %2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-host] SET PARAMETER=%PARAMETER% %1 %2 & SHIFT & SHIFT & GOTO PARAM_LOOP
IF [%1]==[-h] SET PARAMETER=%PARAMETER% %1 %2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-port] SET PARAMETER=%PARAMETER% %1 %2 & SHIFT & SHIFT & GOTO PARAM_LOOP
IF [%1]==[-t] SET PARAMETER=%PARAMETER% %1 %2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-profileName] SET PARAMETER=%PARAMETER% %1 %2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-serverName] SET PARAMETER=%PARAMETER% %1 %2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-nodeName] SET PARAMETER=%PARAMETER% %1 %2 & SHIFT & SHIFT & GOTO PARAM_LOOP

:VERIFY_REQUIRED_INPUTS
IF [%1]==[] SET RC=1 & ECHO Package name is missing. & GOTO PRINT_USAGE
IF [%2]==[] SET RC=1 & ECHO Username is missing. & GOTO PRINT_USAGE
IF [%3]==[] SET RC=1 & ECHO Password is missing. & GOTO PRINT_USAGE

SET FILENAME=%~f1

ECHO Installing package %FILENAME% started ...

:ImportingPackage
ECHO 	Importing package %FILENAME%
CALL "%TOOL_DIR%_internalInstallPackage.bat" %PARAMETER% -username %2 -password %3 "%FILENAME%" PackageInstalled
IF "%ERRORLEVEL%" NEQ "0" GOTO ImportingPackageFail
ECHO 	Importing package %FILENAME% SUCCESSFULLY

:CustomPreInstallTask
ECHO 	Executing custom pre-install task
CALL "%TOOL_DIR%customProcessAppPreInstall.bat" $PARAMETER% -username %2 -password %3 "%FILENAME%"
IF "%ERRORLEVEL%" NEQ "0" GOTO CustomPreInstallTaskFail
ECHO 	Executing custom pre-install task SUCCESSFULLY

:ExecuteInstallationService
ECHO 	Executing installation service for package %FILENAME%
CALL "%TOOL_DIR%_internalInstallPackage.bat" %PARAMETER% -username %2 -password %3 "%FILENAME%" InstallationServiceExecuted
IF "%ERRORLEVEL%" NEQ "0" GOTO ExecuteInstallationServiceFail
ECHO 	Executing installation service for package %FILENAME% SUCCESSFULLY

:MigrateGlobalData
ECHO 	Migrating global data for package %FILENAME%
CALL "%TOOL_DIR%_internalInstallPackage.bat" %PARAMETER% -username %2 -password %3 "%FILENAME%" GlobalAssetMigrated
IF "%ERRORLEVEL%" NEQ "0" GOTO MigrateGlobalDataFail
ECHO 	Migrating global data for package %FILENAME% SUCCESSFULLY

:MigrateInstances
ECHO 	Migrating in-flight instances for package %FILENAME%
CALL "%TOOL_DIR%_internalInstallPackage.bat" %PARAMETER% -username %2 -password %3 "%FILENAME%" InstancedMigrated
IF "%ERRORLEVEL%" NEQ "0" GOTO MigrateInstancesFail
ECHO 	Migrating in-flight instances for package %FILENAME% SUCCESSFULLY

:SendTrackingDefinitions
ECHO 	Sending tracking definitions for package %FILENAME%
CALL "%TOOL_DIR%_internalInstallPackage.bat" %PARAMETER% -username %2 -password %3 "%FILENAME%" TrackingDefinitionsSent
IF "%ERRORLEVEL%" NEQ "0" GOTO SendTrackingDefinitionsFail
ECHO 	Sent tracking definitions for package %FILENAME% SUCCESSFULLY

ECHO SUCCESS!!! PACKAGE %FILENAME% HAS BEEN INSTALLED
GOTO END

:PRINT_USAGE
ECHO.
ECHO Usage: installProcessAppPackage [options...] ^<package name^> ^<username of the process server administrator^> ^<user password^>
ECHO.
ECHO Options:
ECHO   -?, -help                              print this message
ECHO   -h ^<host^>, -host ^<host^>                host of the process server where to deploy the package, required parameter in ND Environment
ECHO   -t ^<port^>, -port ^<port^>                port of the process server where to deploy the package, required parameter in ND Environment
ECHO   -profileName ^<name^>                    profile name
ECHO   -nodeName ^<name^>                       node name, required parameter in ND Environment
ECHO   -serverName ^<name^>                     server name, required parameter in ND Environment
ECHO.
GOTO END

:ImportingPackageFail
ECHO 	Importing package %FILENAME% FAILED
GOTO ERROR

:CustomPreInstallTaskFail
ECHO 	Executing custom pre-install task FAILED
GOTO ERROR

:ExecuteInstallationServiceFail
ECHO 	Executing installation service for package %FILENAME% FAILED
GOTO ERROR

:MigrateGlobalDataFail
ECHO 	Migrating global data for package %FILENAME% FAILED
GOTO ERROR

:MigrateInstancesFail
ECHO 	Migrating in-flight instances for package %FILENAME% FAILED
GOTO ERROR

:SendTrackingDefinitionsFail
ECHO 	Sending tracking definitions for package %FILENAME% FAILED
GOTO ERROR

:ERROR
ECHO FAILED !!! Installation failed with an error. Please see process server's logs for details
GOTO END

:END
EXIT /B %ERRORLEVEL%
