@ECHO OFF

SETLOCAL

ECHO.
ECHO IBM Business Process Manager Search Optimization - Schema Generator
ECHO.

SET SCRIPT_DIR=%~dp0
PUSHD %SCRIPT_DIR%..\..\..\..\bin
CALL "setupCmdLine.bat" %*
POPD

IF NOT "%USER_INSTALL_ROOT%"=="" GOTO setupArguments
ECHO .
ECHO Profile does not exist.
ECHO.
SET RC=1
GOTO help

:setupArguments
SET LOGGING_PROP=-Dcom.lombardisoftware.ant.JULDefaultLogger.level=DEBUG -Djava.util.logging.config.file="%SCRIPT_DIR%/loggingCreate.properties" -Dtw.log4j.init=false
SET LOGGING_PROP=%LOGGING_PROP% -Dcom.lombardi.logging.StringFilter.excludes=contains(db.password);equals(WSVR0072W);equals(WSVR0801I);equals(WKSP0500);equals(WSVR0643I)

SET PLUGINS_DIR=%WAS_HOME%/plugins
SET RUNTIMES_DIR=%WAS_HOME%/runtimes
SET BPM_LIB_DIR=%WAS_HOME%/BPM/Lombardi/lib
SET BPM_JDBCDRIVERS_DIR=%WAS_HOME%/jdbcdrivers

SET CLASSPATH=%SCRIPT_DIR%
SET CLASSPATH=%CLASSPATH%;lib/search-opt.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.bpm.config.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.bpm.config.model.bspace.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.bpm.config.model.federation.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.bpm.config.model.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.bpm.config.model.rest.service.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ffdc.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.hpel.logging.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.admin.core.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.admin.services.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.admin.system.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.bootstrap.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.bpm.repository.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.bpm.utils.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.bpm.wccm.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.emf.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.javaee.dd.common.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.javaee.dd.ejb.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.runtime.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.wccm.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.wsspi.extension.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.wsspi.proxy.extension.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/javax.j2ee.jacc.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/javax.j2ee.servlet.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/org.eclipse.core.runtime_.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/org.eclipse.emf.common.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/org.eclipse.emf.ecore.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/org.eclipse.emf.ecore.xmi.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/org.eclipse.equinox.common_.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/org.eclipse.equinox.registry.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/org.eclipse.osgi_.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/lib/bootstrap.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/jdom.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/langutil.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/log4j.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/psapiclnt.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/psclnt.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/pssearch.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/svrcoreclnt.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/oro.jar
SET CLASSPATH=%CLASSPATH%;%BPM_JDBCDRIVERS_DIR%/DB2/db2jcc_license_cisuz.jar

REM -Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=5005
:run
"%JAVA_HOME%\bin\java" -cp "%CLASSPATH%" %LOGGING_PROP% -Dwas.install.root="%WAS_HOME%" -Dcom.ibm.ws.management.standalone=true -Dwas.repository.root="%USER_INSTALL_ROOT%/config" -Duser.install.root="%USER_INSTALL_ROOT%" com.lombardisoftware.tools.optimization.search.SchemaGenerator %*
SET RC=%ERRORLEVEL%
GOTO end

:help
ECHO.
ECHO Generates schema for pivot tables.
ECHO.
ECHO Usage:
ECHO.
ECHO    SchemaGenerator.bat [-profileName ^<name^>] options
ECHO.
ECHO Options:
ECHO     -profileName ^<name^>                 
ECHO        Profile name
ECHO     -execute
ECHO        The tool should go ahead and create all the schema.
ECHO     -output ^<FILENAME^>
ECHO        Instead of directly creating the schema, the tool should write all the SQL statements it would normally run to modify
ECHO        the database, to the file ^<FILENAME^>.
ECHO     -screen
ECHO        Instead of directly creating the schema, the tool should write all the SQL statements it would normally run to modify
ECHO        the database, to stdout.
ECHO     -deName ^<deName^>
ECHO        the name of the deployment environment. 
ECHO.
ECHO     -?, -help
ECHO        This help message
ECHO.
GOTO end

:end
ECHO.
EXIT /B %RC%
ENDLOCAL